#include "alternating_adaptivemeans_means2gmm_id.h"

#include "../../../base/base.h"
#include "../../../algorithm/initutil.h"

AlternatingAdaptiveMeansAndMeans2GMMID::AlternatingAdaptiveMeansAndMeans2GMMID(fp_type factor, bool spherical, uint32_t s) : seed(s), factor(factor), spherical(spherical)
{
	std::stringstream sstream;
	sstream << "Alt_AdaptMean+Means2GMM";
	if(spherical)
		sstream << "_spherical";
	sstream << "_f" << factor << "_i" << s ;
	this->nametag = sstream.str();
}

GMMDesc AlternatingAdaptiveMeansAndMeans2GMMID::compute(commonutil::DataSet const& input, unsigned int k)
{
	std::mt19937 gen(seed);
	return initutil::alternatingAdaptiveMeanAndMeanToGMM(input, k, gen, factor, spherical);
}
