#include "gonzalez_lloyds_means2gmm_id.h"

#include "../../../base/base.h"
#include "../../../algorithm/initutil.h"

GonzalezLloydsMeans2GMMID::GonzalezLloydsMeans2GMMID(unsigned int substeps, uint32_t s) : seed(s), substeps(substeps)
{
	std::stringstream sstream;
	sstream << "GonzalezLloydsMeans2GMM" << "_s" << substeps << "_i" << s ;
	this->nametag = sstream.str();
}

GMMDesc GonzalezLloydsMeans2GMMID::compute(commonutil::DataSet const& input, unsigned int k)
{
	std::mt19937 gen(seed);
	return initutil::gonzalezLloydsMeans2GMM(input, k, gen, substeps);
}
