#include "uniform_lloyds_means2gmm_id.h"

#include "../../../base/base.h"
#include "../../../algorithm/initutil.h"

UniformLloydsMeans2GMMID::UniformLloydsMeans2GMMID(unsigned int substeps, uint32_t s) : seed(s), substeps(substeps)
{
	std::stringstream sstream;
	sstream << "UniformLloydsMeans2GMM" << "_s" << substeps << "_i" << s ;
	this->nametag = sstream.str();
}

GMMDesc UniformLloydsMeans2GMMID::compute(commonutil::DataSet const& input, unsigned int k)
{
	std::mt19937 gen(seed);
	return initutil::uniformLloydsMeans2GMM(input, k, gen, substeps);
}
